com.smartgwt.client.widgets.form.fields

## Class TimeItem

- java.lang.Object
- - com.smartgwt.client.core.JsObject
  - - com.smartgwt.client.core.DataClass
    - - com.smartgwt.client.core.RefDataClass
      - - com.smartgwt.client.widgets.form.fields.FormItem
        - - com.smartgwt.client.widgets.form.fields.TextItem
          - - com.smartgwt.client.widgets.form.fields.TimeItem

- All Implemented Interfaces:
    com.google.gwt.event.shared.HasHandlers, HasBlurHandlers, HasChangedHandlers, HasChangeHandlers, HasClickHandlers, HasDoubleClickHandlers, HasEditorEnterHandlers, HasEditorExitHandlers, HasFocusHandlers, HasIconClickHandlers, HasIconKeyPressHandlers, HasItemHoverHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasKeyUpHandlers, HasPickerIconClickHandlers, HasTitleClickHandlers, HasTitleDoubleClickHandlers, HasTitleHoverHandlers, HasValueHoverHandlers

      public class TimeItem
      extends TextItem

  FormItem for editing times in a text field or via a set of selector components.

  `timeFormatter` allows you to set the display format for this field. See also String for system-wide settings.

  TimeItem automatically accepts both 12 and 24 hour time as well as partial times and a variety of possible time value separators. Examples:

         11:34:45 AM => 11:34:45
         1:3:5 AM => 01:30:50
         1:3p  => 13:30:00
         11 34 am => 11:34:00
         11-34  => 11:34:00
         113445  => 11:34:45
         13445  => 01:34:45
         1134  => 11:34:00
         134   => 01:34:00

  Values entered by the user are stored as JavaScript `Date` objects in local time. The day, month and year values of this `Date` object are not relevant and should be ignored.

  By default, when used in a `SearchForm` or as a field in a `ListGrid`'s `filter editor`, TimeItems will automatically generate AdvancedCriteria - for example, entering "11:00" into the item will generate a betweenInclusive Criterion that selects all times between 11:00:00 and 11:59:59. If the form is databound and the DataSource is marked as being `allowAdvancedCriteria`:false, the criteria generated will be simple, checking for data with logical time values equal to the displayed value.

- - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.core.RefDataClass

      `id`

    - ### Fields inherited from class com.smartgwt.client.core.JsObject

      `jsObj`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TimeItem()`
    `TimeItem(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `TimeItem(java.lang.String name)`
    `TimeItem(java.lang.String name, java.lang.String title)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `static void` | `changePickerIconDefaults(FormItemIcon defaults)`
    `void` | `deselectValue()` If `useTextField` is true, falls through to standard `FormItem.deselectValue` implementation on this items freeform text entry field.
    `void` | `deselectValue(java.lang.Boolean start)` If `useTextField` is true, falls through to standard `FormItem.deselectValue` implementation on this items freeform text entry field.
    `SelectItem` | `getAmpmItem()` Select item to hold the AM/PM value for the timeItem when `useTextField` is false.
    `SelectItem` | `getAmpmItemProperties()` Custom properties to apply to this timeItem's generated `AM/PM picker`.
    `java.lang.String` | `getAmpmItemTitle()` Title to show for the `AM/PM picker`.
    `TimeDisplayFormat` | `getDisplayFormat()` Deprecated. Use `setTimeFormatter(com.smartgwt.client.types.TimeDisplayFormat)` instead.
    `int` | `getDuration()` When `useTextField` is set to false, this method returns the value of the time expressed as a duration in the `timeUnit` provided.
    `int` | `getDuration(TimeUnit timeUnit)` When `useTextField` is set to false, this method returns the value of the time expressed as a duration in the `timeUnit` provided.
    `java.lang.String` | `getEnteredValue()` Returns the raw text value typed into this items text field if `useTextField` is true (otherwise returns the result of this.getValue()).
    `java.lang.Integer` | `getHourIncrement()` When `useTextField` is false and `hourValues` is unset, this attribute specifies the increment to use when generating entries for the hour picker.
    `SelectItem` | `getHourItem()` Select item to hold the hours portion of the time or `duration` when `useTextField` is false.
    `java.lang.String` | `getHourItemPrompt()` The hover prompt to show for the `hour picker`.
    `SelectItem` | `getHourItemProperties()` Custom properties to apply to this timeItem's generated `hour picker`.
    `java.lang.String` | `getHourItemTitle()` Title to show for the `hour picker`.
    `java.lang.Integer` | `getHourMaxValue()` When `useTextField` is false and `hourValues` is unset, this attribute specifies the maximum value present in the hour picker.
    `java.lang.Integer` | `getHourMinValue()` When `useTextField` is false and `hourValues` is unset, this attribute specifies the minimum value present in the hour picker.
    `java.lang.Integer[]` | `getHourValues()` An array of values to make available in the `hour picker` when `useTextField` is false.
    `java.lang.String` | `getInvalidTimeStringMessage()` Validation error message to display if the user enters an invalid time string.
    `java.lang.String` | `getMask()` Internal-use only for a TimeItem.
    `java.lang.Boolean` | `getMaskOverwriteMode()` Internal-use only for a TimeItem.
    `java.lang.Boolean` | `getMaskSaveLiterals()` Internal-use only for a TimeItem.
    `java.lang.Integer` | `getMillisecondIncrement()` When `useTextField` is false and `millisecondValues` is unset, this attribute specifies the increment to use when generating entries for the millisecond picker.
    `SelectItem` | `getMillisecondItem()` Select item to hold the milliseconds portion of the time or `duration` when `useTextField` is false.
    `java.lang.String` | `getMillisecondItemPrompt()` The hover prompt to show for the `millisecond picker`.
    `SelectItem` | `getMillisecondItemProperties()` Custom properties to apply to this timeItem's generated `millisecond picker`.
    `java.lang.String` | `getMillisecondItemTitle()` Title to show for the `millisecond picker`.
    `java.lang.Integer` | `getMillisecondMaxValue()` When `useTextField` is false and `millisecondValues` is unset, this attribute specifies the maximum value present in the millisecond picker.
    `java.lang.Integer` | `getMillisecondMinValue()` When `useTextField` is false and `millisecondValues` is unset, this attribute specifies the minimum value present in the millisecond picker.
    `java.lang.Integer[]` | `getMillisecondValues()` An array of values to make available in the `millisecond picker` when `useTextField` is false.
    `java.lang.Integer` | `getMinuteIncrement()` When `useTextField` is false and `minuteValues` is unset, this attribute specifies the increment to use when generating entries for the minute picker.
    `SelectItem` | `getMinuteItem()` Select item to hold the minutes portion of the time or `duration` when `useTextField` is false.
    `java.lang.String` | `getMinuteItemPrompt()` The hover prompt to show for the `minute picker`.
    `SelectItem` | `getMinuteItemProperties()` Custom properties to apply to this timeItem's generated `minute picker`.
    `java.lang.String` | `getMinuteItemTitle()` Title to show for the `minute picker`.
    `java.lang.Integer` | `getMinuteMaxValue()` When `useTextField` is false and `minuteValues` is unset, this attribute specifies the maximum value present in the minute picker.
    `java.lang.Integer` | `getMinuteMinValue()` When `useTextField` is false and `minuteValues` is unset, this attribute specifies the minimum value present in the minute picker.
    `java.lang.Integer[]` | `getMinuteValues()` An array of values to make available in the `minute picker` when `useTextField` is false.
    `static TimeItem` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `java.lang.Integer` | `getSecondIncrement()` When `useTextField` is false and `secondValues` is unset, this attribute specifies the increment to use when generating entries for the second picker.
    `SelectItem` | `getSecondItem()` Select item to hold the seconds portion of the time or `duration` when `useTextField` is false.
    `java.lang.String` | `getSecondItemPrompt()` The hover prompt to show for the `second picker`.
    `SelectItem` | `getSecondItemProperties()` Custom properties to apply to this timeItem's generated `seconds picker`.
    `java.lang.String` | `getSecondItemTitle()` Title to show for the `second picker`.
    `java.lang.Integer` | `getSecondMaxValue()` When `useTextField` is false and `secondValues` is unset, this attribute specifies the maximum value present in the second picker.
    `java.lang.Integer` | `getSecondMinValue()` When `useTextField` is false and `secondValues` is unset, this attribute specifies the minimum value present in the second picker.
    `java.lang.Integer[]` | `getSecondValues()` An array of values to make available in the `second picker` when `useTextField` is false.
    `int[]` | `getSelectionRange()` If `useTextField` is true, falls through to standard `com.smartgwt.client.widgets.form.fields.FormItem#getSelectionRange` implementation on this item's freeform text entry field.
    `java.lang.Boolean` | `getShowHourItem()` Controls whether to display the `hourItem` when `useTextField` is false.
    `java.lang.Boolean` | `getShowMillisecondItem()` Controls whether to display the `millisecondItem` when `useTextField` is false.
    `java.lang.Boolean` | `getShowMinuteItem()` Controls whether to display the `minuteItem` when `useTextField` is false.
    `java.lang.Boolean` | `getShowSecondItem()` Controls whether to display the `secondItem` when `useTextField` is false.
    `Alignment` | `getTextAlign()` If `useTextField` is `true`, this property governs the alignment of text within the text field.
    `java.lang.String` | `getTextBoxStyle()` Base CSS class for this item's text box.
    `TextItem` | `getTextField()` Text field to hold the entire time in "type in" format, if `useTextField` is true.
    `TextItem` | `getTextFieldProperties()` Custom properties to apply to the `text field` generated for this timeItem when `useTextField` is true.
    `TimeDisplayFormat` | `getTimeFormatter()` What format should this item's time string be presented in? If unset the format will be derived from `timeFormatter` or the system-side
    `java.lang.Boolean` | `getUse24HourTime()` Whether to enforce 24-hour time in the UI.
    `java.lang.Boolean` | `getUseMask()` If true, a data entry mask will be enabled in the field based on the `timeFormatter`.
    `java.lang.Boolean` | `getUseTextField()` Should we show the time in a text field, or as a number of SelectItems?
    `void` | `selectValue()` If `useTextField` is true, falls through to standard `FormItem.selectValue` implementation on this items freeform text entry field.
    `void` | `setAmpmItemProperties(SelectItem ampmItemProperties)` Custom properties to apply to this timeItem's generated `AM/PM picker`.
    `void` | `setAmpmItemTitle(java.lang.String ampmItemTitle)` Title to show for the `AM/PM picker`.
    `static void` | `setDefaultProperties(TimeItem timeItemProperties)` Class level method to set the default properties of this class.
    `void` | `setDisplayFormat(TimeDisplayFormat timeFormatter)` Deprecated. Use `getTimeFormatter()` instead.
    `void` | `setDisplayFormat(TimeFormatter timeFormatter)` Deprecated. Use `setDisplayFormat(TimeDisplayFormat)` instead.
    `void` | `setHourIncrement(java.lang.Integer hourIncrement)` When `useTextField` is false and `hourValues` is unset, this attribute specifies the increment to use when generating entries for the hour picker.
    `void` | `setHourItemPrompt(java.lang.String hourItemPrompt)` The hover prompt to show for the `hour picker`.
    `void` | `setHourItemProperties(SelectItem hourItemProperties)` Custom properties to apply to this timeItem's generated `hour picker`.
    `void` | `setHourItemTitle(java.lang.String hourItemTitle)` Title to show for the `hour picker`.
    `void` | `setHourMaxValue(java.lang.Integer hourMaxValue)` When `useTextField` is false and `hourValues` is unset, this attribute specifies the maximum value present in the hour picker.
    `void` | `setHourMinValue(java.lang.Integer hourMinValue)` When `useTextField` is false and `hourValues` is unset, this attribute specifies the minimum value present in the hour picker.
    `void` | `setHours(int hours)` Set the hour value of this TimeItem.
    `void` | `setHourValues(java.lang.Integer... hourValues)` An array of values to make available in the `hour picker` when `useTextField` is false.
    `void` | `setInvalidTimeStringMessage(java.lang.String invalidTimeStringMessage)` Validation error message to display if the user enters an invalid time string.
    `void` | `setJavaScriptObject(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `void` | `setMask(java.lang.String mask)` Internal-use only for a TimeItem.
    `void` | `setMaskOverwriteMode(java.lang.Boolean maskOverwriteMode)` Internal-use only for a TimeItem.
    `void` | `setMaskSaveLiterals(java.lang.Boolean maskSaveLiterals)` Internal-use only for a TimeItem.
    `void` | `setMillisecondIncrement(java.lang.Integer millisecondIncrement)` When `useTextField` is false and `millisecondValues` is unset, this attribute specifies the increment to use when generating entries for the millisecond picker.
    `void` | `setMillisecondItemPrompt(java.lang.String millisecondItemPrompt)` The hover prompt to show for the `millisecond picker`.
    `void` | `setMillisecondItemProperties(SelectItem millisecondItemProperties)` Custom properties to apply to this timeItem's generated `millisecond picker`.
    `void` | `setMillisecondItemTitle(java.lang.String millisecondItemTitle)` Title to show for the `millisecond picker`.
    `void` | `setMillisecondMaxValue(java.lang.Integer millisecondMaxValue)` When `useTextField` is false and `millisecondValues` is unset, this attribute specifies the maximum value present in the millisecond picker.
    `void` | `setMillisecondMinValue(java.lang.Integer millisecondMinValue)` When `useTextField` is false and `millisecondValues` is unset, this attribute specifies the minimum value present in the millisecond picker.
    `void` | `setMilliseconds(int milliseconds)` Set the milliseconds value of this TimeItem.
    `void` | `setMillisecondValues(java.lang.Integer... millisecondValues)` An array of values to make available in the `millisecond picker` when `useTextField` is false.
    `void` | `setMinuteIncrement(java.lang.Integer minuteIncrement)` When `useTextField` is false and `minuteValues` is unset, this attribute specifies the increment to use when generating entries for the minute picker.
    `void` | `setMinuteItemPrompt(java.lang.String minuteItemPrompt)` The hover prompt to show for the `minute picker`.
    `void` | `setMinuteItemProperties(SelectItem minuteItemProperties)` Custom properties to apply to this timeItem's generated `minute picker`.
    `void` | `setMinuteItemTitle(java.lang.String minuteItemTitle)` Title to show for the `minute picker`.
    `void` | `setMinuteMaxValue(java.lang.Integer minuteMaxValue)` When `useTextField` is false and `minuteValues` is unset, this attribute specifies the maximum value present in the minute picker.
    `void` | `setMinuteMinValue(java.lang.Integer minuteMinValue)` When `useTextField` is false and `minuteValues` is unset, this attribute specifies the minimum value present in the minute picker.
    `void` | `setMinutes(int minutes)` Set the minute value of this TimeItem.
    `void` | `setMinuteValues(java.lang.Integer... minuteValues)` An array of values to make available in the `minute picker` when `useTextField` is false.
    `void` | `setSecondIncrement(java.lang.Integer secondIncrement)` When `useTextField` is false and `secondValues` is unset, this attribute specifies the increment to use when generating entries for the second picker.
    `void` | `setSecondItemPrompt(java.lang.String secondItemPrompt)` The hover prompt to show for the `second picker`.
    `void` | `setSecondItemProperties(SelectItem secondItemProperties)` Custom properties to apply to this timeItem's generated `seconds picker`.
    `void` | `setSecondItemTitle(java.lang.String secondItemTitle)` Title to show for the `second picker`.
    `void` | `setSecondMaxValue(java.lang.Integer secondMaxValue)` When `useTextField` is false and `secondValues` is unset, this attribute specifies the maximum value present in the second picker.
    `void` | `setSecondMinValue(java.lang.Integer secondMinValue)` When `useTextField` is false and `secondValues` is unset, this attribute specifies the minimum value present in the second picker.
    `void` | `setSeconds(int seconds)` Set the seconds value of this TimeItem.
    `void` | `setSecondValues(java.lang.Integer... secondValues)` An array of values to make available in the `second picker` when `useTextField` is false.
    `void` | `setSelectionRange(int start, int end)` If `useTextField` is true, falls through to standard `FormItem.setSelectionRange` implementation on this items freeform text entry field.
    `void` | `setShowHourItem(java.lang.Boolean showHourItem)` Controls whether to display the `hourItem` when `useTextField` is false.
    `void` | `setShowMillisecondItem(java.lang.Boolean showMillisecondItem)` Controls whether to display the `millisecondItem` when `useTextField` is false.
    `void` | `setShowMinuteItem(java.lang.Boolean showMinuteItem)` Controls whether to display the `minuteItem` when `useTextField` is false.
    `void` | `setShowSecondItem(java.lang.Boolean showSecondItem)` Controls whether to display the `secondItem` when `useTextField` is false.
    `void` | `setTextAlign(Alignment textAlign)` If `useTextField` is `true`, this property governs the alignment of text within the text field.
    `void` | `setTextBoxStyle(java.lang.String textBoxStyle)` Base CSS class for this item's text box.
    `void` | `setTextFieldProperties(TextItem textFieldProperties)` Custom properties to apply to the `text field` generated for this timeItem when `useTextField` is true.
    `void` | `setTimeFormatter(TimeDisplayFormat timeFormatter)` What format should this item's time string be presented in? If unset the format will be derived from `timeFormatter` or the system-side
    `void` | `setUse24HourTime(java.lang.Boolean use24HourTime)` Whether to enforce 24-hour time in the UI.
    `void` | `setUseMask(java.lang.Boolean useMask)` If true, a data entry mask will be enabled in the field based on the `timeFormatter`.
    `void` | `setUseTextField(java.lang.Boolean useTextField)` Should we show the time in a text field, or as a number of SelectItems?

    - ### Methods inherited from class com.smartgwt.client.widgets.form.fields.TextItem

      `getBrowserAutoCapitalize, getBrowserAutoCorrect, getBrowserInputType, getChangeOnKeypress, getCharacterCasing, getFormatOnBlur, getFormatOnFocusChange, getHeight, getHint, getKeyPressFilter, getLength, getMaskPadChar, getMaskPromptChar, getPrintFullText, getSaveOnEnter, getSelectOnClick, getSelectOnFocus, getShowHintInField, getValueAsString, getWidth, setBrowserAutoCapitalize, setBrowserAutoCorrect, setBrowserInputType, setChangeOnKeypress, setCharacterCasing, setDefaultProperties, setFormatOnBlur, setFormatOnFocusChange, setHeight, setKeyPressFilter, setLength, setMaskPadChar, setMaskPromptChar, setPrintFullText, setSaveOnEnter, setSelectOnClick, setSelectOnFocus, setShowHintInField, setWidth`

    - ### Methods inherited from class com.smartgwt.client.widgets.form.fields.FormItem

      `_getValue, addBlurHandler, addChangedHandler, addChangeHandler, addClickHandler, addDoubleClickHandler, addEditorEnterHandler, addEditorExitHandler, addFocusHandler, addIconClickHandler, addIconKeyPressHandler, addItemHoverHandler, addKeyDownHandler, addKeyPressHandler, addKeyUpHandler, addPickerIconClickHandler, addTitleClickHandler, addTitleDoubleClickHandler, addTitleHoverHandler, addValueHoverHandler, asSGWTComponent, blurItem, canEditCriterion, clearValue, disable, enable, focusInItem, getAccessKey, getAlign, getAllowExpressions, getAlwaysFetchMissingValues, getApplyHeightToTextBox, getAriaRole, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsFloat, getAttributeAsInt, getAttributeAsJavaScriptObject, getAttributeAsString, getBrowserSpellCheck, getCanEdit, getCanFocus, getCanvasAutoChild, getCellHeight, getCellStyle, getClassName, getClipStaticValue, getClipTitle, getConfig, getContainerWidget, getCriteriaField, getCriterion, getCriterion, getDataPath, getDateFormatter, getDecimalPad, getDecimalPrecision, getDefaultIconSrc, getDisabled, getDisableIconsOnReadOnly, getDisplayField, getDisplayFieldName, getDisplayValue, getDisplayValue, getEditorTypeConfig, getEditPendingCSSText, getEmptyDisplayValue, getEmptyValueIcon, getEndRow, getErrorIconHeight, getErrorIconSrc, getErrorIconWidth, getErrorMessageWidth, getFetchMissingValues, getFieldName, getFilterLocally, getForm, getFormItemAutoChild, getFullDataPath, getGlobalTabIndex, getHintStyle, getHoverAlign, getHoverDelay, getHoverHeight, getHoverOpacity, getHoverStyle, getHoverVAlign, getHoverWidth, getIcon, getIconHeight, getIconHSpace, getIconPageRect, getIconPrompt, getIconRect, getIconVAlign, getIconWidth, getImageURLPrefix, getImageURLSuffix, getImplicitSave, getImplicitSaveOnBlur, getInputFormat, getLeft, getLocateItemBy, getMultipleValueSeparator, getName, getOperator, getOptionCriteria, getOptionFilterContext, getOptionOperationId, getPageLeft, getPageRect, getPageTop, getPicker, getPickerIconHeight, getPickerIconName, getPickerIconPrompt, getPickerIconProperties, getPickerIconSrc, getPickerIconStyle, getPickerIconWidth, getPrintTextBoxStyle, getPrintTitleStyle, getPrompt, getReadOnlyDisplay, getReadOnlyTextBoxStyle, getRect, getRedrawOnChange, getRejectInvalidValueOnChange, getRequired, getRequiredMessage, getRowSpan, getSelectedRecord, getShouldSaveValue, getShowClippedTitleOnHover, getShowClippedValueOnHover, getShowDisabled, getShowErrorIcon, getShowErrorStyle, getShowErrorText, getShowFocused, getShowFocusedErrorState, getShowFocusedIcons, getShowFocusedPickerIcon, getShowHint, getShowIcons, getShowOverIcons, getShowPickerIcon, getShowRTL, getShowTitle, getShowValueIconOnly, getStartRow, getStopOnError, getSuppressValueIcon, getSynchronousValidation, getTabIndex, getTitle, getTitleAlign, getTitleColSpan, getTitleOrientation, getTitleStyle, getTitleVAlign, getTooltip, getTop, getType, getValidateOnChange, getValidateOnExit, getValidOperators, getVAlign, getValue, getValueAsRecordList, getValueField, getValueFieldName, getValueIconHeight, getValueIconLeftPadding, getValueIconRightPadding, getValueIconSize, getValueIconWidth, getVisible, getVisibleHeight, getVisibleWidth, getWrapTitle, hasAdvancedCriteria, hide, hideIcon, invalidateDisplayValueCache, isCreated, isDisabled, isDrawn, isVisible, redraw, setAccessKey, setAlign, setAllowExpressions, setAlwaysFetchMissingValues, setApplyHeightToTextBox, setAriaRole, setAriaState, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setBrowserSpellCheck, setCanEdit, setCanEditCriterionPredicate, setCanFocus, setCellHeight, setCellStyle, setClipStaticValue, setClipTitle, setColSpan, setColSpan, setCriteriaField, setCriterion, setCriterionGetter, setCriterionSetter, setDataPath, setDateFormatter, setDecimalPad, setDecimalPrecision, setDefaultIconSrc, setDefaultProperties, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDisabled, setDisableIconsOnReadOnly, setDisplayField, setDisplayFormat, setEditorProperties, setEditorType, setEditorType, setEditorType, setEditorValueFormatter, setEditorValueParser, setEditPendingCSSText, setEmptyDisplayValue, setEmptyValueIcon, setEndRow, setErrorFormatter, setErrorIconHeight, setErrorIconSrc, setErrorIconWidth, setErrorMessageWidth, setErrorOrientation, setFetchMissingValues, setFilterLocally, setGlobalTabIndex, setHeight, setHint, setHintStyle, setHoverAlign, setHoverDelay, setHoverHeight, setHoverOpacity, setHoverStyle, setHoverVAlign, setHoverWidth, setIconHeight, setIconHSpace, setIconPrompt, setIcons, setIconVAlign, setIconWidth, setImageURLPrefix, setImageURLSuffix, setImplicitSave, setImplicitSaveOnBlur, setInitHandler, setInputFormat, setInputTransformer, setItemHoverFormatter, setItemTitleHoverFormatter, setItemValueHoverFormatter, setLeft, setLocateItemBy, setMultipleValueSeparator, setName, setOperator, setOptionCriteria, setOptionDataSource, setOptionFilterContext, setOptionOperationId, setPickerIconHeight, setPickerIconName, setPickerIconPrompt, setPickerIconProperties, setPickerIconSrc, setPickerIconStyle, setPickerIconWidth, setPrintTextBoxStyle, setPrintTitleStyle, setPrompt, setProperty, setProperty, setProperty, setProperty, setProperty, setReadOnlyDisplay, setReadOnlyTextBoxStyle, setRedrawOnChange, setRejectInvalidValueOnChange, setRequired, setRequiredMessage, setRowSpan, setShouldSaveValue, setShowClippedTitleOnHover, setShowClippedValueOnHover, setShowDisabled, setShowErrorIcon, setShowErrorStyle, setShowErrorText, setShowFocused, setShowFocusedErrorState, setShowFocusedIcons, setShowFocusedPickerIcon, setShowHint, setShowIcons, setShowIfCondition, setShowOverIcons, setShowPickerIcon, setShowRTL, setShowTitle, setShowValueIconOnly, setStartRow, setStopOnError, setSuppressValueIcon, setSynchronousValidation, setTabIndex, setTitle, setTitleAlign, setTitleColSpan, setTitleHoverFormatter, setTitleOrientation, setTitleStyle, setTitleVAlign, setTooltip, setTop, setType, setValidateOnChange, setValidateOnExit, setValidators, setValidOperators, setVAlign, setValue, setValue, setValue, setValue, setValue, setValue, setValueField, setValueFormatter, setValueHoverFormatter, setValueIconHeight, setValueIconLeftPadding, setValueIconMapper, setValueIconRightPadding, setValueIcons, setValueIconSize, setValueIconWidth, setValueMap, setValueMap, setVisible, setWidth, setWrapTitle, shouldApplyHeightToTextBox, shouldFetchMissingValue, shouldSaveOnEnter, show, showIcon, showPicker, stopHover, updateState, validate, valueClipped`

    - ### Methods inherited from class com.smartgwt.client.core.RefDataClass

      `getRef, getRef, internalSetID`

    - ### Methods inherited from class com.smartgwt.client.core.DataClass

      `doAddHandler, fireEvent, getAttributeAsDoubleArray, getAttributeAsIntArray, getAttributeAsLong, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsStringArray, getAttributes, getHandlerCount, getJsObj, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttributeAsJavaObject`

    - ### Methods inherited from class com.smartgwt.client.core.JsObject

      `equals, hashCode, setJsObj`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### TimeItem

          public TimeItem()

    - #### TimeItem

          public TimeItem(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### TimeItem

          public TimeItem(java.lang.String name)

    - #### TimeItem

          public TimeItem(java.lang.String name,
                  java.lang.String title)

  - ### Method Detail

    - #### getOrCreateRef

          public static TimeItem getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### setJavaScriptObject

          public void setJavaScriptObject(com.google.gwt.core.client.JavaScriptObject jsObj)

      Overrides:
        `setJavaScriptObject` in class `TextItem`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties.
      See Also:
        `AutoChildUsage`

    - #### changePickerIconDefaults

          public static void changePickerIconDefaults(FormItemIcon defaults)

    - #### getAmpmItem

          public SelectItem getAmpmItem()

      Select item to hold the AM/PM value for the timeItem when `useTextField` is false.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        SelectItem

    - #### setAmpmItemProperties

          public void setAmpmItemProperties(SelectItem ampmItemProperties)

      Custom properties to apply to this timeItem's generated `AM/PM picker`.

      Note : This is an advanced setting

      Parameters:
        `ampmItemProperties` - ampmItemProperties Default value is null

    - #### getAmpmItemProperties

          public SelectItem getAmpmItemProperties()

      Custom properties to apply to this timeItem's generated `AM/PM picker`.
      Returns:
        SelectItem

    - #### setAmpmItemTitle

          public void setAmpmItemTitle(java.lang.String ampmItemTitle)

      Title to show for the `AM/PM picker`.
      Parameters:
        `ampmItemTitle` - . See `String`. Default value is "AM/PM"

    - #### getAmpmItemTitle

          public java.lang.String getAmpmItemTitle()

      Title to show for the `AM/PM picker`.
      Returns:
        . See `String`

    - #### setHourIncrement

          public void setHourIncrement(java.lang.Integer hourIncrement)

      When `useTextField` is false and `hourValues` is unset, this attribute specifies the increment to use when generating entries for the hour picker. For example, if this attribute is set to 5, the hour picker will contain only every fifth value between the `hourMinValue` and `hourMaxValue`.
      Parameters:
        `hourIncrement` - hourIncrement Default value is null

    - #### getHourIncrement

          public java.lang.Integer getHourIncrement()

      When `useTextField` is false and `hourValues` is unset, this attribute specifies the increment to use when generating entries for the hour picker. For example, if this attribute is set to 5, the hour picker will contain only every fifth value between the `hourMinValue` and `hourMaxValue`.
      Returns:
        Integer

    - #### getHourItem

          public SelectItem getHourItem()

      Select item to hold the hours portion of the time or `duration` when `useTextField` is false.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        SelectItem

    - #### setHourItemPrompt

          public void setHourItemPrompt(java.lang.String hourItemPrompt)

      The hover prompt to show for the `hour picker`.
      Parameters:
        `hourItemPrompt` - . See `String`. Default value is "Choose hours"

    - #### getHourItemPrompt

          public java.lang.String getHourItemPrompt()

      The hover prompt to show for the `hour picker`.
      Returns:
        . See `String`

    - #### setHourItemProperties

          public void setHourItemProperties(SelectItem hourItemProperties)

      Custom properties to apply to this timeItem's generated `hour picker`.

      Note : This is an advanced setting

      Parameters:
        `hourItemProperties` - hourItemProperties Default value is null

    - #### getHourItemProperties

          public SelectItem getHourItemProperties()

      Custom properties to apply to this timeItem's generated `hour picker`.
      Returns:
        SelectItem

    - #### setHourItemTitle

          public void setHourItemTitle(java.lang.String hourItemTitle)

      Title to show for the `hour picker`.
      Parameters:
        `hourItemTitle` - . See `String`. Default value is "Hour"

    - #### getHourItemTitle

          public java.lang.String getHourItemTitle()

      Title to show for the `hour picker`.
      Returns:
        . See `String`

    - #### setHourMaxValue

          public void setHourMaxValue(java.lang.Integer hourMaxValue)

      When `useTextField` is false and `hourValues` is unset, this attribute specifies the maximum value present in the hour picker.

      Used for specifying a limited set of valid Hour values, or when using the TimeItem to record duration, rather than time per-se. The default is 11 or 23, according to the value of `use24HourTime` and `timeFormatter`.

      See also `hourMinValue` and `hourIncrement`.

      Parameters:
        `hourMaxValue` - hourMaxValue Default value is null

    - #### getHourMaxValue

          public java.lang.Integer getHourMaxValue()

      When `useTextField` is false and `hourValues` is unset, this attribute specifies the maximum value present in the hour picker.

      Used for specifying a limited set of valid Hour values, or when using the TimeItem to record duration, rather than time per-se. The default is 11 or 23, according to the value of `use24HourTime` and `timeFormatter`.

      See also `hourMinValue` and `hourIncrement`.

      Returns:
        Integer

    - #### setHourMinValue

          public void setHourMinValue(java.lang.Integer hourMinValue)

      When `useTextField` is false and `hourValues` is unset, this attribute specifies the minimum value present in the hour picker.

      Used for specifying a limited set of valid Hour values, or when using the TimeItem to record duration, rather than time per-se. The default is zero in all cases.

      See also `hourMaxValue` and `hourIncrement`.

      Parameters:
        `hourMinValue` - hourMinValue Default value is null

    - #### getHourMinValue

          public java.lang.Integer getHourMinValue()

      When `useTextField` is false and `hourValues` is unset, this attribute specifies the minimum value present in the hour picker.

      Used for specifying a limited set of valid Hour values, or when using the TimeItem to record duration, rather than time per-se. The default is zero in all cases.

      See also `hourMaxValue` and `hourIncrement`.

      Returns:
        Integer

    - #### setHourValues

          public void setHourValues(java.lang.Integer... hourValues)

      An array of values to make available in the `hour picker` when `useTextField` is false.

      Used for specifying a limited set of valid Hour values, or when using the TimeItem to record duration, rather than time per-se.

      See `hourMinValue`, `hourMaxValue` and `hourIncrement` for another method of controlling the content in the hour picker.
      If this method is called after the component has been drawn/initialized: Sets the array of valid `hour values` to use when `useTextField` is false.

      Used for limiting available valid Hour values, or when using the TimeItem to record duration, rather than time per-se.

      See `hourMinValue`, `hourMaxValue` and `hourIncrement` for another method of controlling the content in the hour picker.

      Parameters:
        `hourValues` - array of available Hour values. Default value is null

    - #### getHourValues

          public java.lang.Integer[] getHourValues()

      An array of values to make available in the `hour picker` when `useTextField` is false.

      Used for specifying a limited set of valid Hour values, or when using the TimeItem to record duration, rather than time per-se.

      See `hourMinValue`, `hourMaxValue` and `hourIncrement` for another method of controlling the content in the hour picker.

      Returns:
        Returns an array of the current valid hour values, whether set directly as `hourValues` or generated according to `hourMinValue`, `hourMaxValue` and `hourIncrement`.

    - #### setInvalidTimeStringMessage

          public void setInvalidTimeStringMessage(java.lang.String invalidTimeStringMessage)

      Validation error message to display if the user enters an invalid time string.
      Parameters:
        `invalidTimeStringMessage` - . See `String`. Default value is "Invalid time"

    - #### getInvalidTimeStringMessage

          public java.lang.String getInvalidTimeStringMessage()

      Validation error message to display if the user enters an invalid time string.
      Returns:
        . See `String`

    - #### setMask

          public void setMask(java.lang.String mask)

      Internal-use only for a TimeItem.
      If this method is called after the component has been drawn/initialized: A custom mask cannot be defined for a time item.

      Note : This is an advanced setting

      Overrides:
        `setMask` in class `TextItem`
      Parameters:
        `mask` - . See `String`. Default value is null
      See Also:
        `setUseMask(java.lang.Boolean)`

    - #### getMask

          public java.lang.String getMask()

      Internal-use only for a TimeItem.
      Overrides:
        `getMask` in class `TextItem`
      Returns:
        . See `String`
      See Also:
        `getUseMask()`

    - #### setMaskOverwriteMode

          public void setMaskOverwriteMode(java.lang.Boolean maskOverwriteMode)

      Internal-use only for a TimeItem.

      Note : This is an advanced setting

      Overrides:
        `setMaskOverwriteMode` in class `TextItem`
      Parameters:
        `maskOverwriteMode` - maskOverwriteMode Default value is null
      See Also:
        `setUseMask(java.lang.Boolean)`

    - #### getMaskOverwriteMode

          public java.lang.Boolean getMaskOverwriteMode()

      Internal-use only for a TimeItem.
      Overrides:
        `getMaskOverwriteMode` in class `TextItem`
      Returns:
        Boolean
      See Also:
        `getUseMask()`

    - #### setMaskSaveLiterals

          public void setMaskSaveLiterals(java.lang.Boolean maskSaveLiterals)

      Internal-use only for a TimeItem.

      Note : This is an advanced setting

      Overrides:
        `setMaskSaveLiterals` in class `TextItem`
      Parameters:
        `maskSaveLiterals` - maskSaveLiterals Default value is null
      See Also:
        `setUseMask(java.lang.Boolean)`

    - #### getMaskSaveLiterals

          public java.lang.Boolean getMaskSaveLiterals()

      Internal-use only for a TimeItem.
      Overrides:
        `getMaskSaveLiterals` in class `TextItem`
      Returns:
        Boolean
      See Also:
        `getUseMask()`

    - #### setMillisecondIncrement

          public void setMillisecondIncrement(java.lang.Integer millisecondIncrement)

      When `useTextField` is false and `millisecondValues` is unset, this attribute specifies the increment to use when generating entries for the millisecond picker. For example, if this attribute is set to 5, the millisecond picker will contain only every fifth value between the `millisecondMinValue` and `millisecondMaxValue`.
      Parameters:
        `millisecondIncrement` - millisecondIncrement Default value is null

    - #### getMillisecondIncrement

          public java.lang.Integer getMillisecondIncrement()

      When `useTextField` is false and `millisecondValues` is unset, this attribute specifies the increment to use when generating entries for the millisecond picker. For example, if this attribute is set to 5, the millisecond picker will contain only every fifth value between the `millisecondMinValue` and `millisecondMaxValue`.
      Returns:
        Integer

    - #### getMillisecondItem

          public SelectItem getMillisecondItem()

      Select item to hold the milliseconds portion of the time or `duration` when `useTextField` is false.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        SelectItem

    - #### setMillisecondItemPrompt

          public void setMillisecondItemPrompt(java.lang.String millisecondItemPrompt)

      The hover prompt to show for the `millisecond picker`.
      Parameters:
        `millisecondItemPrompt` - . See `String`. Default value is "Choose milliseconds"

    - #### getMillisecondItemPrompt

          public java.lang.String getMillisecondItemPrompt()

      The hover prompt to show for the `millisecond picker`.
      Returns:
        . See `String`

    - #### setMillisecondItemProperties

          public void setMillisecondItemProperties(SelectItem millisecondItemProperties)

      Custom properties to apply to this timeItem's generated `millisecond picker`.

      Note : This is an advanced setting

      Parameters:
        `millisecondItemProperties` - millisecondItemProperties Default value is null

    - #### getMillisecondItemProperties

          public SelectItem getMillisecondItemProperties()

      Custom properties to apply to this timeItem's generated `millisecond picker`.
      Returns:
        SelectItem

    - #### setMillisecondItemTitle

          public void setMillisecondItemTitle(java.lang.String millisecondItemTitle)

      Title to show for the `millisecond picker`.
      Parameters:
        `millisecondItemTitle` - . See `String`. Default value is "Ms"

    - #### getMillisecondItemTitle

          public java.lang.String getMillisecondItemTitle()

      Title to show for the `millisecond picker`.
      Returns:
        . See `String`

    - #### setMillisecondMaxValue

          public void setMillisecondMaxValue(java.lang.Integer millisecondMaxValue)

      When `useTextField` is false and `millisecondValues` is unset, this attribute specifies the maximum value present in the millisecond picker.

      Used for specifying a limited set of valid Millisecond values, or when using the TimeItem to record duration, rather than time per-se. The default is 999.

      See also `millisecondMinValue` and `millisecondIncrement`.

      Parameters:
        `millisecondMaxValue` - millisecondMaxValue Default value is null

    - #### getMillisecondMaxValue

          public java.lang.Integer getMillisecondMaxValue()

      When `useTextField` is false and `millisecondValues` is unset, this attribute specifies the maximum value present in the millisecond picker.

      Used for specifying a limited set of valid Millisecond values, or when using the TimeItem to record duration, rather than time per-se. The default is 999.

      See also `millisecondMinValue` and `millisecondIncrement`.

      Returns:
        Integer

    - #### setMillisecondMinValue

          public void setMillisecondMinValue(java.lang.Integer millisecondMinValue)

      When `useTextField` is false and `millisecondValues` is unset, this attribute specifies the minimum value present in the millisecond picker.

      Used for specifying a limited set of valid Millisecond values, or when using the TimeItem to record duration, rather than time per-se. The default is zero in all cases.

      See also `millisecondMaxValue` and `millisecondIncrement`.

      Parameters:
        `millisecondMinValue` - millisecondMinValue Default value is null

    - #### getMillisecondMinValue

          public java.lang.Integer getMillisecondMinValue()

      When `useTextField` is false and `millisecondValues` is unset, this attribute specifies the minimum value present in the millisecond picker.

      Used for specifying a limited set of valid Millisecond values, or when using the TimeItem to record duration, rather than time per-se. The default is zero in all cases.

      See also `millisecondMaxValue` and `millisecondIncrement`.

      Returns:
        Integer

    - #### setMillisecondValues

          public void setMillisecondValues(java.lang.Integer... millisecondValues)

      An array of values to make available in the `millisecond picker` when `useTextField` is false.

      Used for specifying a limited set of valid Millisecond values, or when using the TimeItem to record duration, rather than time per-se.

      See `millisecondMinValue`, `millisecondMaxValue` and `millisecondIncrement` for another method of controlling the content in the millisecond picker.
      If this method is called after the component has been drawn/initialized: Sets the array of valid `millisecond values` to use when `useTextField` is false.

      Used for limiting available valid Millisecond values, or when using the TimeItem to record duration, rather than time per-se.

      See `millisecondMinValue`, `millisecondMaxValue` and `millisecondIncrement` for another method of controlling the content in the millisecond picker.

      Parameters:
        `millisecondValues` - array of available Millisecond values. Default value is null

    - #### getMillisecondValues

          public java.lang.Integer[] getMillisecondValues()

      An array of values to make available in the `millisecond picker` when `useTextField` is false.

      Used for specifying a limited set of valid Millisecond values, or when using the TimeItem to record duration, rather than time per-se.

      See `millisecondMinValue`, `millisecondMaxValue` and `millisecondIncrement` for another method of controlling the content in the millisecond picker.

      Returns:
        Returns an array of the current valid millisecond values, whether set directly as `millisecondValues` or generated according to `millisecondMinValue`, `millisecondMaxValue` and `millisecondIncrement`.

    - #### setMinuteIncrement

          public void setMinuteIncrement(java.lang.Integer minuteIncrement)

      When `useTextField` is false and `minuteValues` is unset, this attribute specifies the increment to use when generating entries for the minute picker. For example, if this attribute is set to 5, the minute picker will contain only every fifth value between the `minuteMinValue` and `minuteMaxValue`.
      Parameters:
        `minuteIncrement` - minuteIncrement Default value is null

    - #### getMinuteIncrement

          public java.lang.Integer getMinuteIncrement()

      When `useTextField` is false and `minuteValues` is unset, this attribute specifies the increment to use when generating entries for the minute picker. For example, if this attribute is set to 5, the minute picker will contain only every fifth value between the `minuteMinValue` and `minuteMaxValue`.
      Returns:
        Integer

    - #### getMinuteItem

          public SelectItem getMinuteItem()

      Select item to hold the minutes portion of the time or `duration` when `useTextField` is false.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        SelectItem

    - #### setMinuteItemPrompt

          public void setMinuteItemPrompt(java.lang.String minuteItemPrompt)

      The hover prompt to show for the `minute picker`.
      Parameters:
        `minuteItemPrompt` - . See `String`. Default value is "Choose minutes"

    - #### getMinuteItemPrompt

          public java.lang.String getMinuteItemPrompt()

      The hover prompt to show for the `minute picker`.
      Returns:
        . See `String`

    - #### setMinuteItemProperties

          public void setMinuteItemProperties(SelectItem minuteItemProperties)

      Custom properties to apply to this timeItem's generated `minute picker`.

      Note : This is an advanced setting

      Parameters:
        `minuteItemProperties` - minuteItemProperties Default value is null

    - #### getMinuteItemProperties

          public SelectItem getMinuteItemProperties()

      Custom properties to apply to this timeItem's generated `minute picker`.
      Returns:
        SelectItem

    - #### setMinuteItemTitle

          public void setMinuteItemTitle(java.lang.String minuteItemTitle)

      Title to show for the `minute picker`.
      Parameters:
        `minuteItemTitle` - . See `String`. Default value is "Min"

    - #### getMinuteItemTitle

          public java.lang.String getMinuteItemTitle()

      Title to show for the `minute picker`.
      Returns:
        . See `String`

    - #### setMinuteMaxValue

          public void setMinuteMaxValue(java.lang.Integer minuteMaxValue)

      When `useTextField` is false and `minuteValues` is unset, this attribute specifies the maximum value present in the minute picker.

      Used for specifying a limited set of valid Minute values, or when using the TimeItem to record duration, rather than time per-se. The default 59.

      See also `minuteMinValue` and `minuteIncrement`.

      Parameters:
        `minuteMaxValue` - minuteMaxValue Default value is null

    - #### getMinuteMaxValue

          public java.lang.Integer getMinuteMaxValue()

      When `useTextField` is false and `minuteValues` is unset, this attribute specifies the maximum value present in the minute picker.

      Used for specifying a limited set of valid Minute values, or when using the TimeItem to record duration, rather than time per-se. The default 59.

      See also `minuteMinValue` and `minuteIncrement`.

      Returns:
        Integer

    - #### setMinuteMinValue

          public void setMinuteMinValue(java.lang.Integer minuteMinValue)

      When `useTextField` is false and `minuteValues` is unset, this attribute specifies the minimum value present in the minute picker.

      Used for specifying a limited set of valid Minute values, or when using the TimeItem to record duration, rather than time per-se. The default is zero in all cases.

      See also `minuteMaxValue` and `minuteIncrement`.

      Parameters:
        `minuteMinValue` - minuteMinValue Default value is null

    - #### getMinuteMinValue

          public java.lang.Integer getMinuteMinValue()

      When `useTextField` is false and `minuteValues` is unset, this attribute specifies the minimum value present in the minute picker.

      Used for specifying a limited set of valid Minute values, or when using the TimeItem to record duration, rather than time per-se. The default is zero in all cases.

      See also `minuteMaxValue` and `minuteIncrement`.

      Returns:
        Integer

    - #### setMinuteValues

          public void setMinuteValues(java.lang.Integer... minuteValues)

      An array of values to make available in the `minute picker` when `useTextField` is false.

      Used for specifying a limited set of valid Minute values, or when using the TimeItem to record duration, rather than time per-se.

      See `minuteMinValue`, `minuteMaxValue` and `minuteIncrement` for another method of controlling the content in the minute picker.
      If this method is called after the component has been drawn/initialized: Sets the array of valid `minute values` to use when `useTextField` is false.

      Used for limiting available valid Minute values, or when using the TimeItem to record duration, rather than time per-se.

      See `minuteMinValue`, `minuteMaxValue` and `minuteIncrement` for another method of controlling the content in the minute picker.

      Parameters:
        `minuteValues` - array of available Minute values. Default value is null

    - #### getMinuteValues

          public java.lang.Integer[] getMinuteValues()

      An array of values to make available in the `minute picker` when `useTextField` is false.

      Used for specifying a limited set of valid Minute values, or when using the TimeItem to record duration, rather than time per-se.

      See `minuteMinValue`, `minuteMaxValue` and `minuteIncrement` for another method of controlling the content in the minute picker.

      Returns:
        Returns an array of the current valid minute values, whether set directly as `minuteValues` or generated according to `minuteMinValue`, `minuteMaxValue` and `minuteIncrement`.

    - #### setSecondIncrement

          public void setSecondIncrement(java.lang.Integer secondIncrement)

      When `useTextField` is false and `secondValues` is unset, this attribute specifies the increment to use when generating entries for the second picker. For example, if this attribute is set to 5, the second picker will contain only every fifth value between the `secondMinValue` and `secondMaxValue`.
      Parameters:
        `secondIncrement` - secondIncrement Default value is null

    - #### getSecondIncrement

          public java.lang.Integer getSecondIncrement()

      When `useTextField` is false and `secondValues` is unset, this attribute specifies the increment to use when generating entries for the second picker. For example, if this attribute is set to 5, the second picker will contain only every fifth value between the `secondMinValue` and `secondMaxValue`.
      Returns:
        Integer

    - #### getSecondItem

          public SelectItem getSecondItem()

      Select item to hold the seconds portion of the time or `duration` when `useTextField` is false.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        SelectItem

    - #### setSecondItemPrompt

          public void setSecondItemPrompt(java.lang.String secondItemPrompt)

      The hover prompt to show for the `second picker`.
      Parameters:
        `secondItemPrompt` - . See `String`. Default value is "Choose seconds"

    - #### getSecondItemPrompt

          public java.lang.String getSecondItemPrompt()

      The hover prompt to show for the `second picker`.
      Returns:
        . See `String`

    - #### setSecondItemProperties

          public void setSecondItemProperties(SelectItem secondItemProperties)

      Custom properties to apply to this timeItem's generated `seconds picker`.

      Note : This is an advanced setting

      Parameters:
        `secondItemProperties` - secondItemProperties Default value is null

    - #### getSecondItemProperties

          public SelectItem getSecondItemProperties()

      Custom properties to apply to this timeItem's generated `seconds picker`.
      Returns:
        SelectItem

    - #### setSecondItemTitle

          public void setSecondItemTitle(java.lang.String secondItemTitle)

      Title to show for the `second picker`.
      Parameters:
        `secondItemTitle` - . See `String`. Default value is "Sec"

    - #### getSecondItemTitle

          public java.lang.String getSecondItemTitle()

      Title to show for the `second picker`.
      Returns:
        . See `String`

    - #### setSecondMaxValue

          public void setSecondMaxValue(java.lang.Integer secondMaxValue)

      When `useTextField` is false and `secondValues` is unset, this attribute specifies the maximum value present in the second picker.

      Used for specifying a limited set of valid Second values, or when using the TimeItem to record duration, rather than time per-se. The default is 59.

      See also `secondMinValue` and `secondIncrement`.

      Parameters:
        `secondMaxValue` - secondMaxValue Default value is null

    - #### getSecondMaxValue

          public java.lang.Integer getSecondMaxValue()

      When `useTextField` is false and `secondValues` is unset, this attribute specifies the maximum value present in the second picker.

      Used for specifying a limited set of valid Second values, or when using the TimeItem to record duration, rather than time per-se. The default is 59.

      See also `secondMinValue` and `secondIncrement`.

      Returns:
        Integer

    - #### setSecondMinValue

          public void setSecondMinValue(java.lang.Integer secondMinValue)

      When `useTextField` is false and `secondValues` is unset, this attribute specifies the minimum value present in the second picker.

      Used for specifying a limited set of valid Second values, or when using the TimeItem to record duration, rather than time per-se. The default is zero in all cases.

      See also `secondMaxValue` and `secondIncrement`.

      Parameters:
        `secondMinValue` - secondMinValue Default value is null

    - #### getSecondMinValue

          public java.lang.Integer getSecondMinValue()

      When `useTextField` is false and `secondValues` is unset, this attribute specifies the minimum value present in the second picker.

      Used for specifying a limited set of valid Second values, or when using the TimeItem to record duration, rather than time per-se. The default is zero in all cases.

      See also `secondMaxValue` and `secondIncrement`.

      Returns:
        Integer

    - #### setSecondValues

          public void setSecondValues(java.lang.Integer... secondValues)

      An array of values to make available in the `second picker` when `useTextField` is false.

      Used for specifying a limited set of valid Second values, or when using the TimeItem to record duration, rather than time per-se.

      See `secondMinValue`, `secondMaxValue` and `secondIncrement` for another method of controlling the content in the second picker.
      If this method is called after the component has been drawn/initialized: Sets the array of valid `second values` to use when `useTextField` is false.

      Used for limiting available valid Second values, or when using the TimeItem to record duration, rather than time per-se.

      See `secondMinValue`, `secondMaxValue` and `secondIncrement` for another method of controlling the content in the second picker.

      Parameters:
        `secondValues` - array of available Second values. Default value is null

    - #### getSecondValues

          public java.lang.Integer[] getSecondValues()

      An array of values to make available in the `second picker` when `useTextField` is false.

      Used for specifying a limited set of valid Second values, or when using the TimeItem to record duration, rather than time per-se.

      See `secondMinValue`, `secondMaxValue` and `secondIncrement` for another method of controlling the content in the second picker.

      Returns:
        Returns an array of the current valid second values, whether set directly as `secondValues` or generated according to `secondMinValue`, `secondMaxValue` and `secondIncrement`.

    - #### setShowHourItem

          public void setShowHourItem(java.lang.Boolean showHourItem)

      Controls whether to display the `hourItem` when `useTextField` is false.
      Parameters:
        `showHourItem` - showHourItem Default value is true

    - #### getShowHourItem

          public java.lang.Boolean getShowHourItem()

      Controls whether to display the `hourItem` when `useTextField` is false.
      Returns:
        Boolean

    - #### setShowMillisecondItem

          public void setShowMillisecondItem(java.lang.Boolean showMillisecondItem)

      Controls whether to display the `millisecondItem` when `useTextField` is false.
      Parameters:
        `showMillisecondItem` - showMillisecondItem Default value is false

    - #### getShowMillisecondItem

          public java.lang.Boolean getShowMillisecondItem()

      Controls whether to display the `millisecondItem` when `useTextField` is false.
      Returns:
        Boolean

    - #### setShowMinuteItem

          public void setShowMinuteItem(java.lang.Boolean showMinuteItem)

      Controls whether to display the `minuteItem` when `useTextField` is false.
      Parameters:
        `showMinuteItem` - showMinuteItem Default value is true

    - #### getShowMinuteItem

          public java.lang.Boolean getShowMinuteItem()

      Controls whether to display the `minuteItem` when `useTextField` is false.
      Returns:
        Boolean

    - #### setShowSecondItem

          public void setShowSecondItem(java.lang.Boolean showSecondItem)

      Controls whether to display the `secondItem` when `useTextField` is false.
      Parameters:
        `showSecondItem` - showSecondItem Default value is true

    - #### getShowSecondItem

          public java.lang.Boolean getShowSecondItem()

      Controls whether to display the `secondItem` when `useTextField` is false.
      Returns:
        Boolean

    - #### setTextAlign

          public void setTextAlign(Alignment textAlign)

      If `useTextField` is `true`, this property governs the alignment of text within the text field. Defaults to `"left"` by default or `"right"` if the page is in `rtl mode`.
      Overrides:
        `setTextAlign` in class `FormItem`
      Parameters:
        `textAlign` - textAlign Default value is varies
      See Also:
        `Appearance overview and related methods`

    - #### getTextAlign

          public Alignment getTextAlign()

      If `useTextField` is `true`, this property governs the alignment of text within the text field. Defaults to `"left"` by default or `"right"` if the page is in `rtl mode`.
      Overrides:
        `getTextAlign` in class `FormItem`
      Returns:
        Alignment
      See Also:
        `Appearance overview and related methods`

    - #### setTextBoxStyle

          public void setTextBoxStyle(java.lang.String textBoxStyle)

      Base CSS class for this item's text box. If specified this style will be applied to the `textField` if `useTextField` is set to `true`.
      Overrides:
        `setTextBoxStyle` in class `TextItem`
      Parameters:
        `textBoxStyle` - . See `CSSStyleName`. Default value is null
      See Also:
        `Appearance overview and related methods`

    - #### getTextBoxStyle

          public java.lang.String getTextBoxStyle()

      Base CSS class for this item's text box. If specified this style will be applied to the `textField` if `useTextField` is set to `true`.
      Overrides:
        `getTextBoxStyle` in class `TextItem`
      Returns:
        . See `CSSStyleName`
      See Also:
        `Appearance overview and related methods`

    - #### getTextField

          public TextItem getTextField()

      Text field to hold the entire time in "type in" format, if `useTextField` is true.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        TextItem

    - #### setTextFieldProperties

          public void setTextFieldProperties(TextItem textFieldProperties)

      Custom properties to apply to the `text field` generated for this timeItem when `useTextField` is true.

      Note : This is an advanced setting

      Parameters:
        `textFieldProperties` - textFieldProperties Default value is null

    - #### getTextFieldProperties

          public TextItem getTextFieldProperties()

      Custom properties to apply to the `text field` generated for this timeItem when `useTextField` is true.
      Returns:
        TextItem

    - #### setTimeFormatter

          public void setTimeFormatter(TimeDisplayFormat timeFormatter)

      What format should this item's time string be presented in? If unset the format will be derived from `timeFormatter` or the system-side
      Overrides:
        `setTimeFormatter` in class `FormItem`
      Parameters:
        `timeFormatter` - timeFormatter Default value is "toShort24HourTime"
      See Also:
        `Appearance overview and related methods`

    - #### getTimeFormatter

          public TimeDisplayFormat getTimeFormatter()

      What format should this item's time string be presented in? If unset the format will be derived from `timeFormatter` or the system-side
      Overrides:
        `getTimeFormatter` in class `FormItem`
      Returns:
        TimeDisplayFormat
      See Also:
        `Appearance overview and related methods`

    - #### setUse24HourTime

          public void setUse24HourTime(java.lang.Boolean use24HourTime)

      Whether to enforce 24-hour time in the UI.
      Parameters:
        `use24HourTime` - use24HourTime Default value is null

    - #### getUse24HourTime

          public java.lang.Boolean getUse24HourTime()

      Whether to enforce 24-hour time in the UI.
      Returns:
        Boolean

    - #### setUseMask

          public void setUseMask(java.lang.Boolean useMask)

      If true, a data entry mask will be enabled in the field based on the `timeFormatter`.

      Note that if a non-padded `timeFormatter` is specified, it will be changed to the corresponding padded version (ex. "toShort24HourTime" will be changed to "toShortPadded24HourTime").

      Note : This is an advanced setting

      Parameters:
        `useMask` - useMask Default value is null

    - #### getUseMask

          public java.lang.Boolean getUseMask()

      If true, a data entry mask will be enabled in the field based on the `timeFormatter`.

      Note that if a non-padded `timeFormatter` is specified, it will be changed to the corresponding padded version (ex. "toShort24HourTime" will be changed to "toShortPadded24HourTime").

      Returns:
        Boolean

    - #### setUseTextField

          public void setUseTextField(java.lang.Boolean useTextField)

      Should we show the time in a text field, or as a number of SelectItems?
      Parameters:
        `useTextField` - useTextField Default value is true

    - #### getUseTextField

          public java.lang.Boolean getUseTextField()

      Should we show the time in a text field, or as a number of SelectItems?
      Returns:
        Boolean

    - #### deselectValue

          public void deselectValue()

      If `useTextField` is true, falls through to standard `FormItem.deselectValue` implementation on this items freeform text entry field. Otherwise has no effect.
      Overrides:
        `deselectValue` in class `TextItem`

    - #### deselectValue

          public void deselectValue(java.lang.Boolean start)

      If `useTextField` is true, falls through to standard `FormItem.deselectValue` implementation on this items freeform text entry field. Otherwise has no effect.
      Overrides:
        `deselectValue` in class `TextItem`
      Parameters:
        `start` - If this parameter is passed, new cursor insertion position will be moved to the start, rather than the end of this item's value.

    - #### getDuration

          public int getDuration()

      When `useTextField` is set to false, this method returns the value of the time expressed as a duration in the `timeUnit` provided. If no timeUnit is passed, the default is the smallest unit for which a picker is visible.
      Returns:
        the item's value, expressed as a duration in the TimeUnit passed

    - #### getDuration

          public int getDuration(TimeUnit timeUnit)

      When `useTextField` is set to false, this method returns the value of the time expressed as a duration in the `timeUnit` provided. If no timeUnit is passed, the default is the smallest unit for which a picker is visible.
      Parameters:
        `timeUnit` - the unit of the return value
      Returns:
        the item's value, expressed as a duration in the TimeUnit passed

    - #### getEnteredValue

          public java.lang.String getEnteredValue()

      Returns the raw text value typed into this items text field if `useTextField` is true (otherwise returns the result of this.getValue()).
      Overrides:
        `getEnteredValue` in class `TextItem`
      Returns:
        value the user entered

    - #### selectValue

          public void selectValue()

      If `useTextField` is true, falls through to standard `FormItem.selectValue` implementation on this items freeform text entry field. Otherwise has no effect.
      Overrides:
        `selectValue` in class `TextItem`

    - #### setHours

          public void setHours(int hours)

      Set the hour value of this TimeItem.
      Parameters:
        `hours` - new hours value for this TimeItem.

    - #### setMilliseconds

          public void setMilliseconds(int milliseconds)

      Set the milliseconds value of this TimeItem.
      Parameters:
        `milliseconds` - new milliseconds value for this TimeItem.

    - #### setMinutes

          public void setMinutes(int minutes)

      Set the minute value of this TimeItem.
      Parameters:
        `minutes` - new minutes value for this TimeItem.

    - #### setSeconds

          public void setSeconds(int seconds)

      Set the seconds value of this TimeItem.
      Parameters:
        `seconds` - new seconds value for this TimeItem.

    - #### setSelectionRange

          public void setSelectionRange(int start,
                               int end)

      If `useTextField` is true, falls through to standard `FormItem.setSelectionRange` implementation on this items freeform text entry field. Otherwise has no effect.
      Overrides:
        `setSelectionRange` in class `TextItem`
      Parameters:
        `start` - character index for start of new selection
        `end` - character index for end of new selection

    - #### setDefaultProperties

          public static void setDefaultProperties(TimeItem timeItemProperties)

      Class level method to set the default properties of this class. If set, then all subsequent instances of this class will automatically have the default properties that were set when this method was called. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will effect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead.

      Parameters:
        `timeItemProperties` - properties that should be used as new defaults when instances of this class are created

    - #### setDisplayFormat

          public void setDisplayFormat(TimeFormatter timeFormatter)

      Deprecated. Use `setDisplayFormat(TimeDisplayFormat)` instead.
      What format should this item's time string be presented in?
      Overrides:
        `setDisplayFormat` in class `FormItem`
      Parameters:
        `timeFormatter` - displayFormat Default value is "toShort24HourTime"
      See Also:
        `FormItem.setInputFormat(java.lang.String)`, `FormItem.setDateFormatter(com.smartgwt.client.types.DateDisplayFormat)`, `FormItem.setTimeFormatter(com.smartgwt.client.types.TimeDisplayFormat)`

    - #### setDisplayFormat

          @Deprecated
          public void setDisplayFormat(TimeDisplayFormat timeFormatter)

      Deprecated. Use `getTimeFormatter()` instead.
      What format should this item's time string be presented in?
      Parameters:
        `TimeDisplayFormat` - displayFormat Default value is "toShort24HourTime"

    - #### getDisplayFormat

          @Deprecated
          public TimeDisplayFormat getDisplayFormat()

      Deprecated. Use `setTimeFormatter(com.smartgwt.client.types.TimeDisplayFormat)` instead.
      What format should this item's time string be presented in?
      Returns:
        TimeDisplayFormat

    - #### getSelectionRange

          public int[] getSelectionRange()

      If `useTextField` is true, falls through to standard `com.smartgwt.client.widgets.form.fields.FormItem#getSelectionRange` implementation on this item's freeform text entry field. Otherwise has no effect.
      Overrides:
        `getSelectionRange` in class `TextItem`
      Returns:
        2 element array indicating start/end character index of current selection within our text entry field. Returns null if this item is undrawn or doesn't have focus.